﻿using DataVApi.Order;
using DataVApi.Order.RequestModel;
using DataVAPI.Model;
using Microsoft.AspNetCore.Mvc;

namespace DataVAPI.Controllers
{
    /// <summary>
    /// 订单接口:统计订单或者营业额
    /// </summary>
    public class OrderController : BaseController
    {
        string st = System.Reflection.MethodBase.GetCurrentMethod().Name;
        OrderProvider orderProvider = new OrderProvider();
        /// <summary>
        /// 全部数据
        /// </summary>
        [HttpPost]
        public JsonMsg<object> GetAllOrderDataState(FullScreenInput auth)
        {
            st = System.Reflection.MethodBase.GetCurrentMethod().Name;
            try
            {
                object retdata = orderProvider.GetAllOrderDataState(auth);
                return JsonMsg<object>.OK(retdata, st);
            }
            catch (System.Exception ex)
            {
                return JsonMsg<object>.Error(null, st, ex.Message);
            }
        }

        /// <summary>
        /// 折线图
        /// </summary>
        [HttpPost]
        public JsonMsg<object> OrderLine(FullScreenInput auth)
        {
            st = System.Reflection.MethodBase.GetCurrentMethod().Name;
            try
            {
                object retdata = orderProvider.OrderLine(auth);
                return JsonMsg<object>.OK(retdata, st);
            }
            catch (System.Exception ex)
            {
                return JsonMsg<object>.Error(null, st, ex.Message);
            }
        }

        /// <summary>
        /// 区域销售
        /// </summary>
        [HttpPost]
        public JsonMsg<object> GetLocSale()
        {
            st = System.Reflection.MethodBase.GetCurrentMethod().Name;
            try
            {
                object retdata = orderProvider.GetLocSale();
                return JsonMsg<object>.OK(retdata, st);
            }
            catch (System.Exception ex)
            {
                return JsonMsg<object>.Error(null, st, ex.Message);
            }
        }

        /// <summary>
        /// 下单数量
        /// </summary>
        [HttpPost]
        public JsonMsg<object> OrderNumber(FullScreenBasic input)
        {
            st = System.Reflection.MethodBase.GetCurrentMethod().Name;
            try
            {
                object retdata = orderProvider.OrderNumber(input);
                return JsonMsg<object>.OK(retdata, st);
            }
            catch (System.Exception ex)
            {
                return JsonMsg<object>.Error(null, st, ex.Message);
            }
        }
    }
}
